;	THIS ROUTINE DRAWS EITHER THE GRATICLE OR A BOX IN THE 
;	VIDEO MEMORY.  IT LOOKS LIKE:
;
;		CALL GRAT!(GRATON)
;
;			IF GRATON=0 THEN A BOX IS DRAWN, ELSE DRAW 
;			THE ENTIRE GRATICLE 
;
;
;
PAGE,132
GRAT      SEGMENT
          ASSUME    CS:GRAT   
START	  PROC	    FAR	 
	  PUSH	    BP		;SAVE BP
	  MOV	    BP,SP		;GET STACK POINTER
	INC	BP
	INC	BP
	  MOV	    SI,4[BP]		;GET ARGUMENT ADDRESS FROM STACK
	  MOV	    DX,WORD PTR [SI]	;GET ARGUMENT FROM CALLING ROUTINE
		MOV	DI,00H		;START ADDRESS
;  ERASE VIDEO MEMORY
	CLD				;COUNT UP
	PUSH	DS			;STORE DATA SEMENT			
	PUSH	ES			;STORE EXTRA SEGMENT
	MOV	AX,0E000H		;MOV VIDEO ADDRESS TO ES AND DS
	MOV	DS,AX
	MOV	ES,AX
	MOV	AX,00H		;BLANK OUTPUT
;
	MOV	BX,161			;160 ROWS
NEXTR:
	MOV	CX,63D			;LOOP COUNTER
REP	STOS	BYTE PTR [DI]		;BLANK ROW
	ADD	DI,65D			;NEXT ROW
	MOV	SI,DI			;SKIP UNUSED ROWS
	AND	SI,7FFH			;LAST 11 BITS
	CMP	SI,400H
	JLE	NEXT
	ADD	DI,380H
NEXT:
	DEC	BX
	JNZ	NEXTR
	POP	ES			;RESTORE ES
;
;  IF DX<>0 THEN WILL WRITE GRAT, IF DX=0 THEN WILL ERASE GRAT
;
	CMP	DX,00
	JNE	ALL
	JMP	BOX
;
;  NOW DO  VERTICLE LINES
;
ALL:	
         MOV        SI,06H         ;TOP OF FIRST VERTICLE LINE
         MOV        AH,20H         ;OUTPUT BYTE
         CALL       VLINE
;
         MOV        SI,38H        ;TOP OF 9TH LINE
         CALL       VLINE
;
         MOV        SI,0CH        ;TOP OF 2ND LINE
         MOV        AH,08H         ;OUTPUT BYTE
         CALL       VLINE
;
         MOV        SI,25H        ;TOP OF 6TH LINE
         CALL       VLINE
;
         MOV        SI,12H        ;TOP OF 3RD LINE
         MOV        AH,02H         ;OUTPUT BYTE
         CALL       VLINE
;
         MOV        SI,2BH        ;TOP OF 7TH LINE
         CALL       VLINE
;
         MOV        SI,19H        ;TOP OF 4TH LINE
         MOV        AH,80H         ;OUTPUT BYTE
         CALL       VLINE
;
         MOV        SI,32H        ;TOP OF 8TH LINE
         CALL       VLINE
;
         MOV        SI,1FH        ;TOP OF CENTER LINE
         MOV        AH,0A8H        ;HASH MARKS
         CALL       VLINE
;
;
;    NOW DRAW H. LINES AND H. HASH MARKS
;
;
;    FIRST,OUTPUT ALL THE '80H'
;
         MOV        AH,80H
         MOV        DX,05          ;EVERY 5TH BYTE
         MOV        BL,13          ;REPEAT 13 TIMES
         MOV        SI,1100H
         CALL       GRATOUT
         MOV        SI,2200H
         CALL       GRATOUT
         MOV        SI,3300H
         CALL       GRATOUT
         MOV        SI,5880H
         CALL       GRATOUT
         MOV        SI,6980H
         CALL       GRATOUT
       	MOV	SI,7A80H
	CALL	GRATOUT
	MOV	SI,4380H
         CALL       GRATOUT
         MOV        SI,4800H
         CALL       GRATOUT
;
;    ALL THE '20' 
;
         MOV        AH,20H
         MOV        SI,1101H
         CALL       GRATOUT
         MOV        SI,2201H
         CALL       GRATOUT
         MOV        SI,3301H
         CALL       GRATOUT
         MOV        SI,5881H
         CALL       GRATOUT
         MOV        SI,6981H
         CALL       GRATOUT
         MOV        SI,7A81H
         CALL       GRATOUT
         MOV        SI,4381H
         CALL       GRATOUT
         MOV        SI,4801H
         CALL       GRATOUT
;
;    ALL THE '08'
;
         MOV        AH,08H
         MOV        SI,1102H
         CALL       GRATOUT
         MOV        SI,2202H
         CALL       GRATOUT
         MOV        SI,3302H
         CALL       GRATOUT
         MOV        SI,5882H
         CALL       GRATOUT
         MOV        SI,6982H
         CALL       GRATOUT
         MOV        SI,7A82H
         CALL       GRATOUT
         MOV        SI,4382H
         CALL       GRATOUT
         MOV        SI,4802H
         CALL       GRATOUT
;
; I'M NOT SURE WHAT THIS IS, BUT IT MUST BE IMPORTANT
;
         MOV        BL,12D         ;START DOING EVERYTHING 12 TIMES
         MOV        SI,4402H
         CALL       GRATOUT
;
;    NOW DO ALL THE '02'
;
	MOV	AH,02H
	MOV	SI,1103H
	CALL	GRATOUT
         MOV        SI,2203H
         CALL       GRATOUT
         MOV        SI,3303H
         CALL       GRATOUT
         MOV        SI,5883H
         CALL       GRATOUT
         MOV        SI,6983H
         CALL       GRATOUT
         MOV        SI,7A83H
         CALL       GRATOUT
         MOV        SI,4383H
         CALL       GRATOUT
         MOV        SI,4803H
         CALL       GRATOUT
;
;    NOW DO VERTICLE HASH MARKS
;
         MOV        AH,42H         ;HASH MARK
         MOV        SI,4403H
         CALL       GRATOUT
         MOV        AH,10H
         MOV        SI,4404H
         CALL       GRATOUT
;
         MOV        BL,13
         MOV        AH,84H
         MOV        SI,4400H
         CALL       GRATOUT
         MOV        AH,21H
         MOV        SI,4401H
         CALL       GRATOUT
;
         MOV        BL,01H
         MOV        SI,441FH
         MOV        AH,0A9H
         CALL       GRATOUT
;

;
	MOV	BL,3		;ERASE 'FUNNY' HASH MARKS
	MOV	DX,06
	MOV	AH,00
	MOV	SI,4386H
	CALL	GRATOUT
	MOV	SI,43D6H
	CALL	GRATOUT
	MOV	BL,4
	MOV	SI,4399H
	CALL	GRATOUT
	MOV	SI,4819H
	CALL	GRATOUT
	MOV	BL,2
	MOV	SI,43B2H
	CALL	GRATOUT
	MOV	SI,4832H
	CALL	GRATOUT
;
;	LEFT SIDE
BOX:
	MOV	SI,00H
	MOV	AH,80H
	MOV	DX,80H
	MOV	BL,9H
	MOV	BH,17D
LLOOP:	
	CALL	GRATOUT
	ADD	SI,380H
	DEC	BH
	JNZ	LLOOP
	MOV	BL,8H
	CALL	GRATOUT
;
;	RIGHT SIDE
	MOV	SI,3EH
	MOV	AH,08H
	MOV	BH,17D
	MOV	BL,09H
RLOOP:
	CALL	GRATOUT
	ADD	SI,380H
	DEC	BH
	JNZ	RLOOP
	MOV	BL,08H
	CALL	GRATOUT
;
;    TOP LINE OF BOX
;
;
          MOV        AH,0AAH        ;OUTPUT BYTE FOR TOP AND BOTTEM LINES
          MOV        SI,0000H       ;UPPER LEFT CORNER
          MOV        DX,1H          ;CONSECUTIVE OUTPUTS
          MOV        BL,62          ;REPEAT 62 TIMES
          CALL       GRATOUT        ;OUTPUT ROUTINE
;
;    BOTTEM LINE OF BOX
;
          MOV        SI,8B80H       ;BOTTEM LEFT CORNER
          CALL       GRATOUT
;
;    FINISH RIGHTMOST EDGE OF TOP AND BOTTEM LINES
;
          MOV        SI,3EH         ;END OF FIRST LINE
          MOV        AH,0A8H        ;END BYTE
          MOV        BL,02H         ;DO TWICE
          MOV        DX,8B80H       ;END OF LAST LINE IS 8BBEH
          CALL       GRATOUT
;
;
	POP	DS
	MOV	BP,SP		;IF GRAT ON, FIX TWO DOTS THAT WERE LEFT OUT BEFORE
	INC	BP
	INC	BP
	MOV	SI,4[BP]
	MOV	DX,[SI]
	CMP	DX,00
	JZ	DONE
	PUSH 	DS
	MOV	AX,0E000H
	MOV	DS,AX
	MOV	AH,21H
	MOV	BX,441FH
	MOV	[BX],AH
	MOV	AH,84H
	MOV	BX,4400H
	MOV	[BX],AH
;
;
;
	POP	DS				;RESTORE DS
DONE:	POP	BP		
         RET        2
START	ENDP
;
;
;    OUTPUT SUBROUTINE
;
;    AH.....OUTPUT BYTE
;    DX.....INCREMENT BETWEEN OUTPUT ADDRESSES
;    SI.....CONTAINS OUTPUT ADDRESS OF FIRST OUTPUT BYTE
;    BL.....CONTAINS NUMBER OF TIMES PROCEDURE IS TO BE REPEATED
;
;
GRATOUT  PROC
;
         MOV        CL,BL          ;MOVE COUNT TO CX
	MOV	CH,00H
;
OUTLOOP:
	    OR		[SI],AH		;WRITE NEW BYTE
         ADD        SI,DX          ;INCREMENT VIDEO POINTER
         LOOP       OUTLOOP        ;DEC CX AND CONTINUE IF NOT ZERO
         RET
GRATOUT  ENDP
;
;	VERTICAL LINE SUBROUTINE
;
;	AH....OUTPUT BYTE
;	SI....TOP ADDRESS
;
VLINE	PROC
;
	MOV	DI,SI		;SAVE TOP ADDRESS
	MOV	BL,05		;REPEAT 5 TIMES
	MOV	DX,2000H	;INCREMENT
	CALL	GRATOUT		
	MOV	SI,DI		;GET TOP BACK
	ADD	SI,200H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,400H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,980H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,0B80H
	CALL	GRATOUT
	MOV	BL,04		;REPEAT REST 4 TIMES
	MOV	SI,DI
	ADD	SI,1100H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,1300H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,1880H
	CALL	GRATOUT
	MOV	SI,DI
	ADD	SI,1A80H
	CALL	GRATOUT
	RET
VLINE	ENDP	
GRAT     ENDS
          END
