; MAP CONVERTS DATA POINTS TO ROW ADDRESS RELATIVE TO START
; VIDEO MEMORY.  CONVERSION FORMULA IS:
;
;           ROW=INT((256-DATA)*4/5-22.4)
;           ROW ADDRESS=ROW*40           IF ROW EVEN
;                      =(ROW-1)*40+8192  IF ROW ODD
;
    PAGE,132
MAP   SEGMENT
      ASSUME    CS:MAP
START PROC      FAR
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B80H
      DW        8B00H 
      DW        8A80H
      DW        8A00H 
      DW        8980H
      DW        8980H
      DW        8900H 
      DW        8880H
      DW        8800H 
;272
      DW        8400H
      DW        8400H
      DW        8380H 
      DW        8300H
      DW        8280H 
      DW        8200H
      DW        8200H
      DW        8180H 
      DW        8100H
      DW        8080H 
      DW        8000H
      DW        8000H
;256
      DW        7C00H 
      DW        7B80H
      DW        7B00H 
      DW        7A80H
      DW        7A80H
      DW        7A00H 
      DW        7980H
      DW        7900H 
      DW        7880H
      DW        7880H
      DW        7800H
; 240
      DW        7400H
      DW        7380H 
      DW        7300H
      DW        7300H
      DW        7280H 
      DW        7200H
      DW        7180H 
      DW        7100H
      DW        7080H 
      DW        7080H 
      DW        7000H
;224
      DW        6C00H 
      DW        6B80H
      DW        6B00H 
      DW        6B00H 
      DW        6A80H
      DW        6A00H 
      DW        6980H
      DW        6900H 
      DW        6900H 
      DW        6880H
      DW        6800H
;208
      DW        6400H
      DW        6380H 
      DW        6380H 
      DW        6300H
      DW        6280H 
      DW        6200H
      DW        6180H 
      DW        6180H 
      DW        6100H
      DW        6080H 
      DW        6000H
;192
      DW        5C00H 
      DW        5C00H 
      DW        5B80H
      DW        5B00H 
      DW        5A80H
      DW        5A80H
      DW        5A00H 
      DW        5980H
      DW        5900H 
      DW        5880H
      DW        5880H
      DW        5800H
; 176
      DW        5400H
      DW        5380H 
      DW        5300H
      DW        5300H
      DW        5280H 
      DW        5200H
      DW        5180H 
      DW        5100H
      DW        5100H
      DW        5080H 
      DW        5000H
;160
      DW        4C00H 
      DW        4B80H
      DW        4B80H
      DW        4B00H 
      DW        4A80H
      DW        4A00H 
      DW        4980H
      DW        4980H
      DW        4900H 
      DW        4880H
      DW        4800H
;144
      DW        4400H
      DW        4400H
      DW        4380H 
      DW        4300H
      DW        4280H 
      DW        4200H
      DW        4200H
      DW        4180H 
      DW        4100H
      DW        4080H 
      DW        4000H
      DW        4000H
;128
      DW        3C00H 
      DW        3B80H
      DW        3B00H 
      DW        3A80H
      DW        3A80H
      DW        3A00H 
      DW        3980H
      DW        3900H 
      DW        3880H
      DW        3880H
      DW        3800H
;112
      DW        3400H
      DW        3380H 
      DW        3300H
      DW        3300H
      DW        3280H 
      DW        3200H
      DW        3180H 
      DW        3100H
      DW        3100H
      DW        3080H 
      DW        3000H
;96
      DW        2C00H 
      DW        2B80H
      DW        2B80H
      DW        2B00H 
      DW        2A80H
      DW        2A00H 
      DW        2980H
      DW        2980H
      DW        2900H 
      DW        2880H
      DW        2800H
;80
      DW        2400H
      DW        2400H
      DW        2380H
      DW        2300H
      DW        2280H
      DW        2200H
      DW        2200H
      DW        2180H
      DW        2100H
      DW        2080H
      DW        2000H
      DW        2000H
;64
      DW        1C00H 
      DW        1B80H
      DW        1B00H
      DW        1A80H
      DW        1A80H
      DW        1A00H
      DW        1980H
      DW        1900H
      DW        1880H
      DW        1880H
      DW        1800H
;48
      DW        1400H
      DW        1380H
      DW        1300H
      DW        1300H
      DW        1280H
      DW        1200H
      DW        1180H
      DW        1100H
      DW        1100H
      DW        1080H
      DW        1000H
;32
      DW        0C00H
      DW        0B80H
      DW        0B80H
      DW        0B00H
      DW        0A80H
      DW        0A00H
      DW        980H
      DW        980H
      DW        900H 
      DW        880H
      DW        800H
;16
      DW        400H
      DW        400H
      DW        380H 
      DW        300H
      DW        280H 
      DW        200H
      DW        200H
      DW        180H 
      DW        100H
      DW        080H 
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
      DW        0
START ENDP
MAP   ENDS
      END
